package org.apache.bcel.generic;

import org.apache.bcel.classfile.ConstantCP;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.Utility;

public abstract class FieldOrMethod extends CPInstruction implements LoadClass {
   FieldOrMethod() {
   }

   protected FieldOrMethod(short opcode, int index) {
      super(opcode, index);
   }

   /** @deprecated */
   @Deprecated
   public String getClassName(ConstantPoolGen cpg) {
      ConstantPool cp = cpg.getConstantPool();
      ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
      String className = cp.getConstantString(cmr.getClassIndex(), (byte)7);
      return className.startsWith("[") ? "java.lang.Object" : Utility.pathToPackage(className);
   }

   /** @deprecated */
   @Deprecated
   public ObjectType getClassType(ConstantPoolGen cpg) {
      return ObjectType.getInstance(this.getClassName(cpg));
   }

   public ObjectType getLoadClassType(ConstantPoolGen cpg) {
      ReferenceType rt = this.getReferenceType(cpg);
      if (rt instanceof ObjectType) {
         return (ObjectType)rt;
      } else {
         throw new ClassGenException(rt.getClass().getCanonicalName() + " " + rt.getSignature() + " does not represent an ObjectType");
      }
   }

   public String getName(ConstantPoolGen cpg) {
      ConstantPool cp = cpg.getConstantPool();
      ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
      ConstantNameAndType cnat = (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
      return ((ConstantUtf8)cp.getConstant(cnat.getNameIndex())).getBytes();
   }

   public ReferenceType getReferenceType(ConstantPoolGen cpg) {
      ConstantPool cp = cpg.getConstantPool();
      ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
      String className = cp.getConstantString(cmr.getClassIndex(), (byte)7);
      if (className.startsWith("[")) {
         return (ArrayType)Type.getType(className);
      } else {
         className = Utility.pathToPackage(className);
         return ObjectType.getInstance(className);
      }
   }

   public String getSignature(ConstantPoolGen cpg) {
      ConstantPool cp = cpg.getConstantPool();
      ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
      ConstantNameAndType cnat = (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
      return ((ConstantUtf8)cp.getConstant(cnat.getSignatureIndex())).getBytes();
   }
}
